/**********************************************************
*                                                         *
* (c) 2008 - 2011 LnK                                     *
*                                                         *
* LnKSLIMbusScriptBuilder_IF.h                            *
* Version 1.0                                             *
*                                                         *
* Header file for LnKSLIMbusScriptBuilder_IF DLL          *
*                                                         *
* Date 12 March 2011                                      *
*                                                         *
* Johan Klewais                                           *
*                                                         *
* www.lnk-tools.com - info@lnk-tools.com                  *
*                                                         *
**********************************************************/


extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBOpen(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBClose(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBGetSWVersion(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBGetDLLVersion(void);

extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBFileLoad(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBFileSave(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBFileAppend(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBFileCSVImport(char * filename, int LogicalAddress  );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBFileXMLExport(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSBFileClearAll( void );




// Return values defines

#define	LNK_SCRIPTBUILDER_OK							0
#define LNK_SCRIPTBUILDER_NOT_FOUND						(-1)
#define LNK_SCRIPTBUILDER_ACTION_NOT_ALLOWED			(-2)
#define LNK_SCRIPTBUILDER_FILE_WRITE_ERROR				(-3)
#define LNK_SCRIPTBUILDER_FILE_READ_ERROR				(-4)
#define LNK_SCRIPTBUILDER_XML_TRANSLATION_ERROR			(-5)
#define LNK_SCRIPTBUILDER_COMMAND_BUSY					(-6)
#define LNK_SCRIPTBUILDER_INVALID_VALUE					(-7)
#define LNK_SCRIPTBUILDER_ERROR_LAST					(-8)



// int _stdcall LnKSLIMbusSBOpen(void);
//
// This function opens the interface to the SLIMbus Scriptbuilder application
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//


// int _stdcall LnKSLIMbusSBClose(void);
//
// This function closes the interface to the SLIMbus Scriptbuilder application
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//


// int _stdcall LnKSLIMbusSBGetSWVersion(void);
//
// This function requests the version number of the software of the SLIMbus Scriptbuilder application
//
// Input parameters: 
//						- none
//
// Return value: 
//						- version  (in decimal ex. 153 means 1.53) 
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusGetDLLVersion(void);
//
// This function requests the version number of this DLL of the SLIMbus Scriptbuilder application
//
// Input parameters: 
//						- none
//
// Return value: 
//						- version  (in decimal ex. 100 means 1.00) 
//						
//



// int _stdcall LnKSLIMbusSBFileLoad(char * filename );
//
// This function loads the  '*.lst' file as the current script in Scriptbuilder.
//
// Input parameters: 
//						- char * filename
//							This filename will be used as the currect script.
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//						- LNK_SCRIPTBUILDER_FILE_READ_ERROR
//



// int _stdcall LnKSLIMbusSBFileSave(char * filename );
//
// This function saves the current script loaded in Scriptbuilder into an '*.lst' file
//
// Input parameters: 
//						- char * filename
//							This filename will be used to save the currect script as an lst file 
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//						- LNK_SCRIPTBUILDER_FILE_WRITE_ERROR
//


// int _stdcall LnKSLIMbusSBFileAppend(char * filename );
//
// This function appends this file to the current loaded script in Scriptbuilder.
//
// Input parameters: 
//						- char * filename
//							This filename will be appended to the currect script
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//						- LNK_SCRIPTBUILDER_FILE_WRITE_ERROR
//						- LNK_SCRIPTBUILDER_FILE_READ_ERROR
//


// int _stdcall LnKSLIMbusSBFileCSVImport(char * filename, int LogicalAddress  );
//
// This function imports a CSV file to the current loaded script in Scriptbuilder.
//
// Input parameters: 
//						- char * filename
//							The CSV filename that will be imported into the currect script
//
//						- int LogicalAddress 
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//						- LNK_SCRIPTBUILDER_FILE_READ_ERROR
//


// int _stdcall LnKSLIMbusSBFileXMLExport(char * filename );
//
// This function exports the current loaded script in Scriptbuilder.to an XML script to be used in the Traffic Generator
//
// Input parameters: 
//						- char * filename
//							The XML filename that will contain the exported XML code for the Traffic generator.
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//						- LNK_SCRIPTBUILDER_FILE_READ_ERROR
//


// int _stdcall LnKSLIMbusSBFileClearAll( void );
//
// This function clears all????
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SCRIPTBUILDER_OK
//						- LNK_SCRIPTBUILDER_NOT_FOUND
//						- LNK_SCRIPTBUILDER_COMMAND_BUSY
//						- LNK_SCRIPTBUILDER_FILE_READ_ERROR ??
//						- LNK_SCRIPTBUILDER_FILE_WRITE_ERROR ??





